#!/bin/sh
#
# Attempt to mount any added block devices 
# and remove any removed devices
#

MOUNT="/bin/mount"
PMOUNT="/usr/bin/pmount"
UMOUNT="/bin/umount"
ACTION=$1
name=$2

if [ $ACTION != "remove" ] && [ $ACTION != "add" ]
then
    name=$ACTION
    ACTION="add"
fi

DEVNAME="/dev/$name"

automount() {	
	! test -d "/media/$name" && mkdir -p "/media/$name"
	
	if ! $MOUNT -t auto -o async $DEVNAME "/media/$name"
	then
		rmdir "/media/$name" 2> /dev/null
	else
		echo "Auto-mount of [/media/$name] successful" > /dev/console

		touch "/tmp/.automount-$name"

                #
                # Try to run TeeJet auto-run files. 
                # 
                [ -x /etc/tjrunthumb ] && /etc/tjrunthumb /media/$name
	fi
}
	

if [ $ACTION == "add" ] && [ -n "$DEVNAME" ]; then
	if [ -x $MOUNT ]; then
    		$MOUNT $DEVNAME 2> /dev/null
	fi

	# If the device isn't mounted at this point, it isnt configured in fstab
	cat /proc/mounts | awk '{print $1}' | grep -q "^$DEVNAME$" || automount 
	
fi

if [ $ACTION == "remove" ] && [ -x "$UMOUNT" ] && [ -n "$DEVNAME" ]; then
	for mnt in `cat /proc/mounts | grep "$DEVNAME" | cut -f 2 -d " " `
	do
		$UMOUNT $mnt
	done
	
	# Remove empty directories from auto-mounter
	test -e "/tmp/.automount-$name" && rmdir "/media/$name" 2> /dev/null
fi
